/************************************************************************************************************

  	ToolBox.cpp

	Copyright (c)1990 - 1999 MetaCreations. All rights reserved.

	Author:	Jerome Bignon

	Date:	19/07/99

	Revision History

	when		who			what & why
	=========== ===========	=============================================================
	19/07/99	Jerome		Creation

************************************************************************************************************/

#include "ToolBox.h"
#include "PublicUtilities.h"


/*Product between two transformations*/
/*
TTransform3D  operator *(const TTransform3D &AA,const TTransform3D &BB)
{
	TTransform3D  res;
	WireMultiply(res.fRotationAndScale,AA.fRotationAndScale,BB.fRotationAndScale);
	WireTransformPoint(res.fTranslation,AA,BB.fTranslation);
	return res;
}
*/

/*Redefining a product between two 3D matrices */
void WireMultiply(TMatrix33 &res,const TMatrix33 &AA,const TMatrix33 &BB)
{
	TMatrix33 CC;

	CC[0][0]=AA[0][0]*BB[0][0] + AA[0][1]*BB[1][0] + AA[0][2]*BB[2][0];
	CC[0][1]=AA[0][0]*BB[0][1] + AA[0][1]*BB[1][1] + AA[0][2]*BB[2][1];
	CC[0][2]=AA[0][0]*BB[0][2] + AA[0][1]*BB[1][2] + AA[0][2]*BB[2][2];

	CC[1][0]=AA[1][0]*BB[0][0] + AA[1][1]*BB[1][0] + AA[1][2]*BB[2][0];
	CC[1][1]=AA[1][0]*BB[0][1] + AA[1][1]*BB[1][1] + AA[1][2]*BB[2][1];
	CC[1][2]=AA[1][0]*BB[0][2] + AA[1][1]*BB[1][2] + AA[1][2]*BB[2][2];

	CC[2][0]=AA[2][0]*BB[0][0] + AA[2][1]*BB[1][0] + AA[2][2]*BB[2][0];
	CC[2][1]=AA[2][0]*BB[0][1] + AA[2][1]*BB[1][1] + AA[2][2]*BB[2][1];
	CC[2][2]=AA[2][0]*BB[0][2] + AA[2][1]*BB[1][2] + AA[2][2]*BB[2][2];

	res=CC;
}

void WireTransformPoint(TVector3 &res,const TTransform3D &AA,const TVector3 &VV)
{
	WireTransform(res,AA.fRotationAndScale,VV);	
	res[0] += AA.fTranslation[0] ;
	res[1] += AA.fTranslation[1] ;
	res[2] += AA.fTranslation[2] ;
}

/*Internal use */
void WireTransform(TVector3 &res,const TMatrix33 &AA,const TVector3 &VV)
{
	TVector3 QQ;

	QQ[0]=AA[0][0]*VV[0] + AA[0][1]*VV[1] + AA[0][2]*VV[2] ;
	QQ[1]=AA[1][0]*VV[0] + AA[1][1]*VV[1] + AA[1][2]*VV[2] ;
	QQ[2]=AA[2][0]*VV[0] + AA[2][1]*VV[1] + AA[2][2]*VV[2] ;

	res=QQ;
}
